<!DOCTYPE html>
<html lang="{{ $.Site.Language }}">
    <head>
        <meta charset="utf-8" />
        <meta name="viewport" content="width=device-width, initial-scale=1" />

        {{ $CSS := resources.Match "css/**.css" |  resources.Concat "etke.css" | resources.Minify }}
        {{ $CSSF := $CSS | resources.Fingerprint }}
        {{ $JS := resources.Match "js/**.js" |  resources.Concat "etke.js" | resources.Minify }}
        {{ $JSF := $JS | resources.Fingerprint }}
        <link rel="preload" href="{{ $CSS.RelPermalink | absURL }}?{{ $CSSF.Data.Integrity }}" as="style">
        <link rel="preload" href="{{ $JS.RelPermalink | absURL }}?{{ $JSF.Data.Integrity }}" as="script">
        <link rel="preload" href="{{ .Site.BaseURL }}img/logo.small.webp" as="image" title="{{ .Site.Params.name }} logo">
        <link rel="preload" href="{{ .Site.BaseURL }}img/worker.webp" as="image" title="{{ .Site.Params.name }} - {{ .Site.Params.description }}">

        <link rel="stylesheet" href="{{ $CSS.RelPermalink }}?{{ $CSSF.Data.Integrity }}" media="all">
        <link rel="canonical" href="{{ .Permalink }}" />
        <link rel="me" href="{{ .Site.Params.Mastodon }}" />

        <meta name="description" content="{{ if .Params.Description }}{{ .Params.Description }}{{ else }}{{ block "meta_description" . -}}{{ T "default_meta_description" }}{{ end }}{{ end }}"/>

        {{ if .Params.redirect }}
        <meta http-equiv="refresh" content="0; url={{ .Params.redirect }}"/>
        {{ end }}

        {{ range .AlternativeOutputFormats -}}
        {{ printf `<link rel="%s" type="%s" href="%s" title="%s" />` .Rel .MediaType.Type .Permalink $.Site.Title | safeHTML }}
        {{ end -}}

        {{ if .IsTranslated }}
        {{ range .Translations }}
        <link rel="alternate" href="{{ .RelPermalink }}" hreflang="{{ .Language }}"/>
        {{ end }}
        {{ end }}

        {{ $title := print .Site.Params.Name " | " .Title }}
        {{ if .IsHome }}{{ $title = print .Site.Params.Name " | " .Site.Params.Title }}{{ end }}

        <title>{{block "title" . }}
        {{- $title := print .Site.Params.Name " | " .Title -}}
        {{- if .IsHome -}}{{- $title = print .Site.Params.Name " | " .Site.Params.Title -}}{{- end -}}
        {{- $title -}}
        {{ end }}</title>
        <!-- OGP -->
        <meta property="og:site_name" content="{{ .Site.Params.Name }}" />
        <meta property="og:title" content="{{ $title }}" />
        {{ if .Params.Description }}
        <meta property="og:description" content="{{ .Params.Description }}" />
        {{ else }}
        <meta property="og:description" content="{{ .Site.Params.Description }}" />
        {{ end }}
        <meta property="og:url" content="{{ .Permalink }}" />
        <meta property="og:type" content="website" />
        <meta property="og:image" content="{{ .Site.BaseURL }}img/logo.png" />
        <meta property="og:image:secure_url" content="{{ .Site.BaseURL }}img/logo.png" />

        <meta property="twitter:card" content="summary" />
        <meta property="twitter:title" content="{{ $title }}" />
        {{ if .Params.Description }}
        <meta property="twitter:description" content="{{ .Params.Description }}" />
        {{ else }}
        <meta property="twitter:description" content="{{ .Site.Params.Description }}" />
        {{ end }}
        <meta property="twitter:site" content="{{ .Site.Params.Twitter }}" />
        <meta property="twitter:creator" content="{{ .Site.Params.Twitter }}" />
        <meta property="twitter:image" content="{{ .Site.BaseURL }}img/logo.png" />
        <!-- icons -->
        <link rel="apple-touch-icon" sizes="57x57" href="{{ .Site.BaseURL }}img/icons/apple-icon-57x57.jpg">
        <link rel="apple-touch-icon" sizes="60x60" href="{{ .Site.BaseURL }}img/icons/apple-icon-60x60.jpg">
        <link rel="apple-touch-icon" sizes="72x72" href="{{ .Site.BaseURL }}img/icons/apple-icon-72x72.jpg">
        <link rel="apple-touch-icon" sizes="76x76" href="{{ .Site.BaseURL }}img/icons/apple-icon-76x76.jpg">
        <link rel="apple-touch-icon" sizes="114x114" href="{{ .Site.BaseURL }}img/icons/apple-icon-114x114.jpg">
        <link rel="apple-touch-icon" sizes="120x120" href="{{ .Site.BaseURL }}img/icons/apple-icon-120x120.jpg">
        <link rel="apple-touch-icon" sizes="144x144" href="{{ .Site.BaseURL }}img/icons/apple-icon-144x144.jpg">
        <link rel="apple-touch-icon" sizes="152x152" href="{{ .Site.BaseURL }}img/icons/apple-icon-152x152.jpg">
        <link rel="apple-touch-icon" sizes="180x180" href="{{ .Site.BaseURL }}img/icons/apple-icon-180x180.jpg">
        <link rel="icon" type="image/jpeg" sizes="192x192"  href="{{ .Site.BaseURL }}img/icons/android-icon-192x192.jpg">
        <link rel="icon" type="image/jpeg" sizes="32x32" href="{{ .Site.BaseURL }}img/icons/favicon-32x32.jpg">
        <link rel="icon" type="image/jpeg" sizes="96x96" href="{{ .Site.BaseURL }}img/icons/favicon-96x96.jpg">
        <link rel="icon" type="image/jpeg" sizes="16x16" href="{{ .Site.BaseURL }}img/icons/favicon-16x16.jpg">
        <link rel="manifest" href="{{ .Site.BaseURL }}img/icons/manifest.json">
        <meta name="msapplication-config" content="{{ .Site.BaseURL }}img/icons/browserconfig.xml">
        <meta name="msapplication-TileColor" content="#ffffff">
        <meta name="msapplication-TileImage" content="{{ .Site.BaseURL }}img/icons/ms-icon-144x144.jpg">
        <meta name="theme-color" content="#061621">
        <meta name="color-scheme" content="light dark">
        <script type="application/ld+json">
        {
            "@context": "https://schema.org",
            "@type": "Organization",
            "url": "{{ .Site.BaseURL }}",
            "logo": "{{ .Site.BaseURL }}img/logo.png"
        }
        </script>

        {{ if not hugo.IsServer }}
            <script defer data-domain="etke.cc" src="https://uhoh.etke.cc/js/script.js"></script>
        {{ end }}
        {{- block "head" . }}{{- end }}
    </head>
    <body>
        <script src="{{ $JS.RelPermalink | absURL }}?{{ $JSF.Data.Integrity }}"></script>
        <main class="d-flex flex-column container-fluid p-0">
            {{- partial "header.html" . -}}
            {{- block "main" . }}{{- end }}
        </main>

        {{- partial "footer.html" . -}}

        <script>
            (function () {
                var htmlEl = document.getElementsByTagName('html')[0];

                let applyTheme = function (themeName) {
                    if (themeName === 'light') {
                        htmlEl.removeAttribute('class');
                    } else {
                        htmlEl.className = themeName;
                    }
                };

                document.addEventListener('DOMContentLoaded', (event) => {
                    let themeName = localStorage.getItem('theme');

                    if (!themeName) {
                        let prefersDark = window.matchMedia('(prefers-color-scheme: dark)').matches;
                        themeName = (prefersDark ? 'dark' : 'light');
                    }

                    applyTheme(themeName);
                });

                document.querySelectorAll('.js-btn-toggle-theme').forEach(node => {
                    node.addEventListener('click', () => {
                        var isCurrentlyDark = htmlEl.className.includes("dark");

                        let newThemeName = (isCurrentlyDark ? 'light' : 'dark');

                        localStorage.setItem('theme', newThemeName);

                        applyTheme(newThemeName);
                    });
                });
            })();
        </script>
    </body>
</html>
